%global real_name Analog
%global minus_name analog

%global devver 1

%if %{devver}
%global gitver 876d8a3bb
%endif

Name:           php-Analog
Summary:        PHP micro logging package
Version:        1.0.0
%if %{devver}
Release:        2.git%{gitver}%{?dist}
%else
Release:        1%{?dist}
%endif
%if %{devver}
#git clone git://github.com/jbroadway/analog.git
#cd analog
#git archive --format=tar --prefix=analog-%%{version}-git%%{gitver}/ %%{gitver} | bzip2 > ../analog-%%{version}-git%%{gitver}.tar.bz2
Source0:        %{minus_name}-%{version}-git%{gitver}.tar.bz2
%else
Source0:        https://github.com/downloads/jbroadway/%{minus_name}/%{minus_name}-%{version}-stable.tar.gz
%endif
Source1:        php-Analog-LICENSE
Patch0:         php-Analog-unittests_fix.patch
URL:            https://github.com/jbroadway/analog
License:        MIT
Group:          Development/Libraries

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch

BuildRequires:  php-pear(pear.phpunit.de/PHPUnit)

Requires:       php-common >= 5.3.0
Requires:       php-spl, php-date, php-json
Requires:       php-pcre, php-curl


%description
MicroPHP logging package based on the idea of using closures for
configurability and extensibility. It functions as a static class,
but you can completely control the writing of log messages through
a closure function (aka anonymous functions).

Analog also comes with over a dozen pre-written handlers,
with examples for each in the examples folder. These include:
- Amon - Send logs to the Amon server monitoring tool
- Buffer - Buffer messages to send all at once (works with File,
  Mail, Stderr, and Variable handlers)
- File - Append messages to a file
- FirePHP - Send messages to FirePHP browser plugin
- GELF - Send message to the Graylog2 log management server
- LevelBuffer - Buffer messages and send only if sufficient error
  level reached
- Mail - Send email notices
- Mongo - Save to MongoDB collection, requires php-pecl(mongo)
  package to be installed
- Multi - Send different log levels to different handlers
- Null - Do nothing
- Post - Send messages over HTTP POST to another machine
- Stderr - Send messages to STDERR
- Syslog - Send messages to syslog
- Variable - Buffer messages to a variable reference.

So while it's a micro class, it's highly extensible and very capable
out of the box too.


%prep
%if %{devver}
%setup -qn %{minus_name}-%{version}-git%{gitver}
%else
%setup -qn %{minus_name}-%{version}-stable
%endif
#files that should not exist
find ./ -name "._*.php" -exec rm -f '{}' \;
#include license file
cp -a %{SOURCE1} LICENSE

#patch unit tests, see:
#https://github.com/jbroadway/analog/issues/3
%patch0 -p1


%build
# empty build section, nothing required


%install
rm -rf $RPM_BUILD_ROOT

# install framework files
install -d $RPM_BUILD_ROOT%{_datadir}/php
cp -a lib/%{real_name} $RPM_BUILD_ROOT%{_datadir}/php/


%check
#could fail because of seconds in date comparison
phpunit tests

%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc LICENSE README.md examples lib/%{real_name}.php
%dir %{_datadir}/php/%{real_name}
%{_datadir}/php/%{real_name}/*


%changelog
* Sun Dec 30 2012 Johan Cwiklinski <johan AT x-tnd DOT be> - 1.0.0-2.git876d8a3bb
- Fix a typo
- Run tests, add relevant BR and patch

* Sun Dec 30 2012 Johan Cwiklinski <johan AT x-tnd DOT be> - 1.0.0-1.git876d8a3bb
- Fix version
- remove not needeed php-hash requirement
- remove php-mongo requirement (add a line in %%description)
- remove unneeded macro
- add LICENSE file (upstream bug https://github.com/jbroadway/analog/issues/2)

* Mon Dec 24 2012 Johan Cwiklinski <johan AT x-tnd DOT be> - 1.0.0.1-1.git876d8a3bb
- Latest snapshot (bug fixes, new handlers)
- Fix Requires

* Sun Dec 01 2012 Johan Cwiklinski <johan AT x-tnd DOT be> - 1.0.0-1
- Initial packaging
